//
//  Shader.fsh
//  EmitterDrawer
//
//  Created by mango on 7/22/13.
//  Copyright (c) 2013 mango. All rights reserved.
//
precision lowp float;

varying vec2 texcoordOut;
varying vec2 texcoordSrc;

uniform vec4 color;
uniform sampler2D texture;
uniform sampler2D srcTexture;
uniform mediump float opacity;

const vec4 shadowColor = vec4(0.0,0.0,0.0,1.0);

void main()
{
    vec4 pen = texture2D(texture,texcoordOut);
    vec4 backColor = vec4(shadowColor.rgb,pen.r);
    vec4 topColor = texture2D(srcTexture,texcoordSrc);
    vec3 finalColor = mix(backColor.rgb,topColor.rgb,topColor.a);
    gl_FragColor = vec4(finalColor.rgb,pen.r);
}