precision highp float;

varying vec2 refreshTextureCoordinate;
varying vec2 imageTextureCoordinate;
varying vec2 centers;

uniform sampler2D inputImageTexture;
uniform sampler2D inputPenTexture;
uniform sampler2D overlapTexture;

uniform highp vec2 textureSize;

uniform highp vec2 forceSize;

void main(void)
{
    vec4 pen = texture2D(inputPenTexture,imageTextureCoordinate);
    vec2 tempTextureCoordinate = refreshTextureCoordinate;
    
    
    float scale = max(forceSize.x / textureSize.x,forceSize.y / textureSize.y);
    vec2 scaleSize = textureSize * scale;
    
    
    vec2 offset = (scaleSize - forceSize) * 0.5;
    
    vec2 xy = tempTextureCoordinate * forceSize;
    vec4 overlapColor = texture2D(overlapTexture, (xy + offset) / scaleSize);
    
    vec4 originColor = texture2D(inputImageTexture, refreshTextureCoordinate);
    vec4 result = vec4(overlapColor.rgb + (originColor.rgb * (1.0 - overlapColor.a)), 1.0);
    gl_FragColor = vec4(result.rgb, pen.r);
}