precision highp float;
varying vec2 refreshTextureCoordinate;
varying vec2 imageTextureCoordinate;
varying vec2 centers;

uniform sampler2D inputImageTexture;
uniform sampler2D inputPenTexture;

uniform vec2 texSize;
uniform vec2 mosaicSize;
void main()
{
    vec4 pen = texture2D(inputPenTexture,imageTextureCoordinate);
    vec2 intXY = vec2(refreshTextureCoordinate.x * texSize.x, refreshTextureCoordinate.y * texSize.y);
    vec2 XYMosaic = vec2(floor(intXY.x / mosaicSize.x) * mosaicSize.x,floor(intXY.y / mosaicSize.y) * mosaicSize.y);
    vec2 UVMosaic = vec2(XYMosaic.x / texSize.x,XYMosaic.y / texSize.y);
    vec4 result = texture2D(inputImageTexture,UVMosaic);
    gl_FragColor = vec4(result.rgb,pen.a);
}