#extension GL_EXT_shader_framebuffer_fetch : require
precision highp float;

varying vec2 refreshTextureCoordinate;
varying vec2 imageTextureCoordinate;
varying vec2 centers;

uniform sampler2D inputImageTexture;
uniform sampler2D inputPenTexture;

const lowp int GAUSSIAN_SAMPLES = 13;
varying highp vec2 blurCoordinates[GAUSSIAN_SAMPLES];

void main(void)
{
    highp vec4 sum = vec4(0.0);
    sum += texture2D(inputImageTexture, blurCoordinates[0]) * 0.046118;
    sum += texture2D(inputImageTexture, blurCoordinates[1]) * 0.058552;
    sum += texture2D(inputImageTexture, blurCoordinates[2]) * 0.071181;
    sum += texture2D(inputImageTexture, blurCoordinates[3]) * 0.082860;
    sum += texture2D(inputImageTexture, blurCoordinates[4]) * 0.092356;
    sum += texture2D(inputImageTexture, blurCoordinates[5]) * 0.098568;
    sum += texture2D(inputImageTexture, blurCoordinates[6]) * 0.100731;
    sum += texture2D(inputImageTexture, blurCoordinates[7]) * 0.098568;
    sum += texture2D(inputImageTexture, blurCoordinates[8]) * 0.092356;
    sum += texture2D(inputImageTexture, blurCoordinates[9]) * 0.082860;
    sum += texture2D(inputImageTexture, blurCoordinates[10]) * 0.071181;
    sum += texture2D(inputImageTexture, blurCoordinates[11]) * 0.058552;
    sum += texture2D(inputImageTexture, blurCoordinates[12]) * 0.046118;
    
    
    vec4 pen = texture2D(inputPenTexture,imageTextureCoordinate);
    gl_FragColor = vec4(sum.rgb,pen.a);
}