//
//  RWTSphere.fsh
//  RWTPixelShader
//
//  Created by Ricardo on 3/23/14.
//  Copyright (c) 2014 RayWenderlich. All rights reserved.
//

// Precision
#extension GL_EXT_shader_framebuffer_fetch : require

precision highp float;

varying vec2 texcoordOut;
varying vec2 texcoordSrc;
varying vec2 refreshTextureCoordinate;

uniform vec2 texSize;
uniform vec2 mosaicSize;

uniform sampler2D drawTexture;
uniform sampler2D texture;
uniform sampler2D srcTexture;
uniform sampler2D backbuffer;
uniform mediump float opacity;

void main()
{
    vec4 pen = texture2D(texture,texcoordOut);
    
    // 求得每个马赛克块的大小
    vec2 overlapSampleDivisor = vec2(mosaicSize.x / texSize.x, mosaicSize.y / texSize.y);
    
    // 求出每行每列能放下几个马赛克
    float xIndex = ceil(refreshTextureCoordinate.x / overlapSampleDivisor.x);
    float yIndex = ceil(refreshTextureCoordinate.y / overlapSampleDivisor.y);
    
    // 转成纹理坐标
    vec2 overlapTextureCoord;
    overlapTextureCoord.x = (refreshTextureCoordinate.x - (overlapSampleDivisor.x * (xIndex - 1.0))) / overlapSampleDivisor.x;
    overlapTextureCoord.y = (refreshTextureCoordinate.y - (overlapSampleDivisor.y * (yIndex - 1.0))) / overlapSampleDivisor.y;
    
    // 计算出每个顶点对应的马赛克纹素
    vec4 overlapTextureColor = texture2D(drawTexture,overlapTextureCoord);
    gl_FragColor = mix(gl_LastFragData[0],overlapTextureColor,pen.r);
}
